# Author renyupeng
# coding=utf-8
# @Time    : 2021/12/20 11:18 上午
# @Site    : 
# @File    : send_material_report_weekly.py.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import datetime
from urllib import parse
import pandas as pd
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from sqlalchemy import create_engine


class send_material_report_weekly:
    def __init__(self):
        self.OuterStr = "mysql+pymysql://%s:%s@%s:%d/%s" % (
            "hcst", parse.quote_plus("hcst@2021"), "192.168.0.184", 3390, "application")
        self.OuterConn = create_engine(self.OuterStr,
                                       pool_size=10,
                                       max_overflow=5,
                                       pool_timeout=10,
                                       pool_recycle=3600)
        self.stat_date = (datetime.date.today() + datetime.timedelta(-1)).strftime("%Y-%m-%d")

    def handler(self):
        sql = """select a.company_id as '分公司id',a.company_name as '分公司名称',a.account_id as '账户id',a.account_name as'账户名称',a.project_name as'项目名称',
a.signature as '素材id',b.media_time as '素材上线时间',a.video_name as '素材名称',sum(a.charge) as '消耗',
a.clip_name as '剪辑',a.shot_name  as '拍摄',a.plan_name as '编导',a.leader_name as '负责人',a.photo_url as '视频链接',a.channel_name as '渠道类型'
from 
(select * from  application.kuaishou_material_video_report_daily_dw  where stat_date between 20211201 and 20211231) a
left join application.app_bytedance_material_info   b 
ON a.signature=b.material_id
group by a.account_id,a.signature""".format(stat_date=self.stat_date)
        print(sql)
        path = """/data/excel/material_week_{stat_date}.xls""".format(stat_date=self.stat_date)
        print(path)
        pd.read_sql(sql, self.OuterConn).to_excel(path, index=False, engine='openpyxl')
        my_sender = 'zhaohailiang@c-top.com.cn'  # 发件人邮箱账号
        my_pass = 'Ab*75137'  # 发件人邮箱授权码 / 腾讯企业邮箱请使用登陆密码
        recipients = ['renyupeng@c-top.com.cn',]  # 收件人邮箱账号
        # content = "Please check the attachment. "
        msg = MIMEMultipart()
        # [发件人的邮箱昵称、发件人邮箱账号], 昵称随便
        msg['From'] = my_sender
        # [收件人邮箱昵称、收件人邮箱账号], 昵称随便
        msg['To'] = ",".join(recipients)
        # 邮件的主题，也就是邮件的标题
        msg['Subject'] = "快手-全量素材月报"

        att1 = MIMEText(
            open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename="material_report_weekly.xls"'
        msg.attach(att1)
        server = smtplib.SMTP_SSL("smtp.exmail.qq.com", port=465)
        server.login(my_sender, my_pass)
        try:
            server.sendmail(my_sender, recipients, msg.as_string())
            print("发送成功")
        except Exception as e:
            print("发送失败",e)


if __name__ == '__main__':
    send_material_report_weekly().handler()
